%% initial setting 
% modify the following initalial settings for your purposes
l = 4;          % number of levels
N = 25;          % number of design sites
p = 1;          % dimension of input space X
domain = 10;     % the domain of input space starting from 0
numTest = 0;
% true parameters
tbeta = [0 0 0 0];
tsigma = [2 4 3 5];
tphi= [2 2.1 2.2 2.3];
ttheta = [2.5681    0.5548    2.1481    0.5355    2.1763    1.1510];
tTao = trilelm(PD(ttheta)*PD(ttheta)', -1)';
trndErr = 0.1;

% design sites for Multivator
level = struct('S', {[]}, 'Y', {[]});
design = repmat(level, l, 1);
trial = repmat(level, l, 1);
X = linspace(0, domain, N)';
for i = 1 : l
    design(i).S = X;
    trial(i).S = [];
end

%% Asymptotics
% get asymptotic covariance
[acov1, acov2] = asymp_cov_PWGP(design, @regpoly0, tphi, tsigma, ttheta, trndErr);


%% Show results in table 1 of the paper
sqrt(diag(acov1/400))
sqrt(diag(acov2/400))