%% initial setting 
% modify the following initalial settings for your purposes
l = 4;              % number of levels
N = 25;             % number of design sites
p = 1;              % dimension of input space X
domain = 10;        % the domain of input space starting from 0
numTest = 0;

% set true values for parameters
tbeta = [0 0 0 0];
tsigma = [2 4 3 5];
tphi= 2;
ttheta = [2.5681    0.5548    2.1481    0.5355    2.1763    1.1510];
tTao = trilelm(PD(ttheta)*PD(ttheta)', -1)';
trndErr = 0.1;

% design sites for Multivator
level = struct('S', {[]}, 'Y', {[]});
design = repmat(level, l, 1);
trial = repmat(level, l, 1);

X = linspace(0, domain, N)';
for i = 1 : l
    design(i).S = X;
    trial(i).S = [];
end

%% Asymptotics
acov = asymp_cov_SepMGP(design, @regpoly0, tphi, tsigma, ttheta, trndErr, 0);

