function [B] = average_coeff(k, np)
    npairs = k*(k-1)/2;
    B = zeros(3*k+npairs+1, np*k);
    for p = 1 : npairs

        % for beta
        q = 0;
        B(k*q+r(p),np*(p-1)+2*q+1) = 1;
        B(k*q+s(p),np*(p-1)+2*q+2) = 1;
        % for phi
        q = 1;
        B(k*q+r(p),np*(p-1)+2*q+1) = 1;
        B(k*q+s(p),np*(p-1)+2*q+2) = 1;
        % for sigma
        q = 2;
        B(k*q+r(p),np*(p-1)+2*q+1) = 1;
        B(k*q+s(p),np*(p-1)+2*q+2) = 1;
        % for random error
        q = 3;
        B(k*q+1,np*(p-1)+2*q+1) = 1;
        % for alpha
        B(k*q+p+1,np*(p-1)+2*q+2) = 1;
    end
    B = B ./ repmat(sum(B,2), 1, size(B,2));
end
    
function i = r(p)
    low = ceil(sqrt(2*p+0.25)+0.5);
    up = floor(sqrt(2*p-1.75)+1.5);
    if low == up
        i = low;
    else 
        error('');
    end
end

function j = s(p)
    low = ceil(sqrt(2*p+0.25)+0.5);
    up = floor(sqrt(2*p-1.75)+1.5);
    if low == up
        i = low;
    else 
        error('');
    end
    j = p - (i-1)*(i-2)/2;
end