function [ theta ] = invPD( C )
    C = tril(C,-1);
    n = size(C,1);
    B=tril(ones(n),0);

    % parameters of cross correlation matrix
    T = zeros(size(B));

    %Step 1: calculate correlation coefficients in the first column
    for i = 2 : n
        if(abs(C(i,1)) > 1)
            C(i, 1) = sign(C(i,1));
        end    
    end
    B(2:n, 1) = C(2:n, 1);
    T(2:n, 1) = acos(B(2:n, 1));
    for i= 2:n
        B(i,2:i)=sqrt(1-C(i,1)^2);
    end

    %Step 2: calculate the rest of correlation coefficients
    for i=3:n
        for j= 2:i-1
            B1=B(j,1:j-1)*B(i,1:j-1)';
            B2=B(j,j)*B(i,j);
            Z=B1+B2;
            Y=B1-B2;

            cosinv=(C(i,j)-B1)/B2;

            if isfinite(cosinv)==false 

            elseif cosinv >=1 
                B(i,j)=B(i,j);
                B(i,j+1:n)=0;
                T(i,j) = 0;
            elseif cosinv <=-1
                B(i,j)=-B(i,j);
                B(i,j+1:n)=0;
                T(i,j) = pi;
            else
                B(i,j)=B(i,j)*cosinv;
                T(i,j) = acos(cosinv);
                sinTheta=sqrt(1-cosinv^2);
                for k=j+1:n
                    B(i,k)=B(i,k)*sinTheta;
                end
            end
        end
    end
    
    theta = pi/2*ones(1,(n-1)*n/2);
    for i = 1 : n
        for j =1 : i-1
            theta((i-2)*(i-1)/2+j)=T(i,j);
        end
    end

end

