 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %
 %  sliceLHD: Function to generate sliced Latin hypercube designs
 %  Arguments: 
 %        m: the sample size of the small LHD 
 %        n: the sample size of the large LHD, where n = mt
 %        t: the number of slices
 %        q: the number of factors 
 %    Value: a n-by-q LHD with t slices forming a small LHD of size m
 %           
 %    Last Update: 04/25/2010, YD Hwang and Peter Qian
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [xmat] = slhd(m, t, q)
	n = m*t ;
	P = zeros(m, t);
	Q = zeros(m, t);
	xmat = zeros(m,q,t) ;
		for l = 1:q      
			for j = 1:t 
			P(:,j) = randsample(1:m, m);
			end     
			for i = 1:m 
			Q(i,:) = randsample(1:t, t);
			end
			newP = P;
			for j = 1:t
				for i = 1:m
					for k = 1:m
						if P(i,j)== k 
						newP(i,j) = (k-1)*t + Q(k,j) ;
						end
					end    
				end
			end
		U =  rand(size(newP))/n;
xmat(:,l,:)  = ((newP-1)/n +U);
end

