function [ acov1, acov2 ] = asympt( dmodelPW )
    design = dmodelPW.design;
    l = length(design);
    regr = dmodelPW.regr;
    tphi = dmodelPW.theta(1:l);
    tsigma = dmodelPW.sigma';
    ttheta = dmodelPW.theta(l+1:l*(l+1)/2);
    trndErr = dmodelPW.rndErr;

    % [ C, design ] = cov_fun( design, .@regpoly0 );
    [J, H] = asymp_cov_parfor(design, regr, tphi, tsigma, ttheta, trndErr);
    B1 = average_coeff(l, 2*size(H,1)/(l*(l-1)));
    acov1 = B1*(inv(H)*J*inv(H)')*B1';

    dT = derv_T(l, ttheta);
    B2 = blkdiag(eye(size(acov1,1)-size(dT,1)),dT');
    acov2 = B2*acov1*B2';
end

