addpath('..\Stochastic_PWGP\');
addpath('..\Simulation_Study\Asymptotics\Asymptotics_PWGP_Fomular\');
load('bootstrap.mat', 'design');

% assemble data
l = length(design);
r = size(design(1).Y,2);
p = size(design(1).S,2);

% init
initTheta = pi/2 * ones(1, l*(l-1)/2);      %initial theta for search algorithm
initPhi = 0.1*ones(1,l*p);
initSigma = 7*ones(1,l);

[d1, d2] = meshgrid(1:l, 1:l);
UB = [ 10*repmat(ones(1, p),1,l)            pi*ones(1, l*(l-1)/2)-0.2       20*ones(1,l) ];
LB = [ 0*repmat(ones(1, p),1,l)+0.0001      invPD(exp(-0.03*abs(d1-d2)))    2*ones(1,l)];
clear d1 d2;

options = optimset('Algorithm','active-set', 'RelLineSrchBnd', 0.2, ...
    'RelLineSrchBndDuration', 200, 'Display','off');

% MLE for the all data
theta0 = [  initPhi     initTheta   initSigma];
[dmodel, ~] = dacefit_Pairwise(design, @regpoly0, {@corr_PW_gauss @corr_MV_gauss}, theta0, LB, UB, 'fmincon', options);

% theoretical asymptotics
[acov1, acov2 ] = asympt( dmodel );