function [design, designs] = sample_data()
    addpath('..\Stochastic_PWGP\');
    
    load TR_450_620.mat;
    TR = TR_450_620;
    Plate = TR(:,1);
    Position = TR(:,2);
    wl = 450:5:620;
    regfun = @regpoly0;

    l = max(Position);  % number of levels
    l = ceil(l/2);
    m = max(Plate);
    q = length(regfun(0));

    % design sites for Multivator
    level = struct('S', {[]}, 'Y', {[]});
    design = repmat(level, l, 1);
    for i = 1 : l
        indPos = find(Position == i*2-1);
        design(i).S = wl(1:2:end)'/100;
        design(i).Y = TR(indPos,3:2:end)';
        design(i).Y = design(i).Y - repmat(mean(design(i).Y,2),1,m);
    end

    r = 20;
    iter = 200;

    designs = cell(iter,1);

    for k = 1 : iter
        design_k = design;
        index = randperm(m,r);
        for i = 1 : l
            design_k(i).Y = design_k(i).Y(:,index);
        end
        designs{k} = design_k;
    end