% this function aims to plot figure 2 in the paper, by loading *.mat
% results from the corresponding folder.
clear;
load('..\Asymptotics_PWGP_Fomular\theoretical_asymptotics_N=25.mat', 'J', 'H');
load('..\fmincon_asymptotics_r=10_MLE_N=25_err=0.1_highcorr_50th.mat');

B1 = average_coeff(l, 2*size(H,1)/(l*(l-1)));
acovPW = B1*(inv(H)*J*inv(H)')*B1';
dT = derv_T(4, ttheta);
dT = [eye(size(dT)); dT'];
dT = dT([1:2 4 3 5:end], :);
B2 = blkdiag(eye(size(acovPW,1)-size(dT,2)),dT);
acovPW = B2*acovPW*B2';

theta = theta(:,[1:2 4 3 5:6]);
ttheta = ttheta([1:2 4 3 5:6]);
estimates = [beta phi sigma rndErr theta Tao];
tpara = repmat([tbeta tphi tsigma trndErr ttheta tTao], iter, 1);
estimates = estimates - tpara;

index = [1:13 (20:25)-6];
estimates = estimates(:,index);
acovPW = acovPW(index,index);
Q = zeros(iter,1);
C = chol(acovPW/r);
for i = 1 : iter
    para = estimates(i,:)';    
	para = C' \ para;
    Q(i) = para'*para;
end

figure;  hold on;
plot(1:iter, Q);
plot(1:iter, chi2inv(0.995,size(C,1))*ones(1,iter),'r');
plot(1:iter, chi2inv(0.01,19)*ones(1,iter),'r');
hold off;


figure; hold on; 
[nelements,centers] = hist(Q,2:60);
bar(centers,nelements/iter)
plot(centers, chi2pdf(centers,size(C,1))/sum(chi2pdf(centers,size(C,1))), 'k');
axis([2 50 0 0.08])
hold off;