% this function aims to plot figure 3 in the paper, by loading *.mat
% results from the corresponding folder.
clear;
load('..\Asymptotics_PWGP_Fomular\theoretical_asymptotics_N=25_l=8.mat', 'J', 'H');
load('..\fmincon_asymptotics_r=5_MLE_N=25_err=0.1_l=8_50th.mat');

B1 = average_coeff(l, 2*size(H,1)/(l*(l-1)));
acovPW = B1*(inv(H)*J*inv(H)')*B1';

estimates = [beta phi sigma rndErr theta];
tpara = repmat([tbeta tphi tsigma trndErr ttheta], iter, 1);
estimates = estimates - tpara;

index = true(1, size(acovPW,1));
estimates = estimates(:,index);
acovPW = acovPW(index,index);
Q = zeros(iter,1);
C = chol(acovPW/r);
for i = 1 : iter
    para = estimates(i,:)';    
	para = C' \ para;
    Q(i) = para'*para;
end

figure;  hold on;
plot(1:iter, Q);
plot(1:iter, chi2inv(0.995,size(C,1))*ones(1,iter),'r');
plot(1:iter, chi2inv(0.01,size(C,1))*ones(1,iter),'r');
hold off;


figure; hold on; 
[nelements,centers] = hist(Q,20:1.8:100);
bar(centers,nelements/iter)
plot(centers, chi2pdf(centers,size(C,1))/sum(chi2pdf(centers,size(C,1))), 'k');
axis([20 100 0 0.08])
hold off;