% this aims to get the theoretical asymptotic distribution for MGP with
% nonseparable covariance function, similar as those given in the equation
% 7 of the paper

addpath('..\..\..\Stochastic_PWGP');
initSetting;

[J, H, C] = asymp_cov(design, @regpoly0, tphi, tsigma, ttheta, trndErr, 0);

acov1 = inv(H);

dT = derv_T(4, ttheta);
dT = [eye(size(dT)); dT'];
dT = dT([1:2 4 3 5:end], :);
B2 = [zeros(1,size(dT,2)) 1; dT zeros(size(dT,1),1)];
B2 = blkdiag(eye(size(acov1,1)-size(B2,2)),B2);
acov2 = B2*acov1*B2';

n = 400;
aSTD = sqrt(diag(acov2/n));
