% this function aims to get the sample distribution of parameter
% estimation for MGP with separable covariance function
addpath('..\..\..\Stochastic_PWGP\')

initSetting;
iter = 50000;                        % number of iterations
r = 20;                             % number of repeated data
% store parameter estimates 
phi = zeros(iter, p);
theta = zeros(iter, l*(l-1)/2);
beta = zeros(iter, l);
sigma = zeros(iter, l);
Tao = zeros(iter, l*(l-1)/2);
rndErr = zeros(iter, 1);

% setting for searching algorithm for MLE
initTheta = pi/2 * ones(1, l*(l-1)/2);      
initPhi = 2;                                
initSigma = 20*ones(1,l);                   
options = optimset('Algorithm','active-set', 'RelLineSrchBnd', 0.5, ...
    'RelLineSrchBndDuration', 500, 'Display','off');

theta0 = [  initPhi     initTheta   initSigma];
UB = [ 10*ones(1,p)           pi*ones(1, l*(l-1)/2)-0.1   200*ones(1,l) ];
LB = [ 0*ones(1,p)+0.0001     zeros(1, l*(l-1)/2)+0.1     5*ones(1,l)  ];
parfor k = 1 : iter
    disp(k);
    [design, ~] = randomSP(design0, trial, tbeta', tsigma',tphi, ttheta, trndErr, r);
    
    % multivator model fitting
    [dmodelMV, perfMV] = dacefit_MV_Sep(design, @regpoly0, @corr_MV_gauss, theta0, LB, UB, 'fmincon', options);
    phi(k,:) = dmodelMV.theta(1:p);
    beta(k,:) = dmodelMV.beta';
    sigma(k,:) = dmodelMV.sigma';
    theta(k,:) = dmodelMV.theta(p+(1:l*(l-1)/2));
    Tao(k,:) = trilelm(dmodelMV.CC, -1)';
    rndErr(k,:) = dmodelMV.rndErr;
end
estimates = [beta phi sigma rndErr theta Tao];