function [ dT ] = derv_T( k, theta )
    
    code = 'syms';
    for i = 1 : k
       for j = 1 : i-1
            code = [code ' a' num2str(i) num2str(j)];
       end
    end
    eval(code);
    alpha = [];
    code = 'alpha = [';
    for i = 1 : k
       for j = 1 : i-1
            code = [code ' a' num2str(i) num2str(j)];
       end
    end
    code = [code ' ];'];
    eval(code);

    T = cross_corr(k, alpha);
    dT = derv(T, alpha);
    dT = eval(subs(dT, alpha, theta));
end

function T = cross_corr(k, alpha)
    
    L = sym(zeros(k));
    L(1,1) = sym(1);
    for i = 2 : k
        tL = 1;
        for j = 1 : i-1
            p = (i - 2)*(i - 1)/2 + j;
            L(i,j) = cos(alpha(p))*tL;
            tL = tL*sin(alpha(p));    
        end
        L(i,i) = tL;
    end
    T = L*transpose(L);
    T = simple(T);
end

function  dT = derv(T, alpha)
    
    n = length(alpha);
    T = trilelm(T, -1);
    dT = sym(zeros(n));
   
    for i = 1 : n
        for j =1 : n
            dT(i,j) = diff(T(j),alpha(i));
        end
    end
    
end

% function [ V ] = trilelm( A )
%   
%     k = size(A,1);
%     n = k*(k-1)/2;
%     V = sym(zeros(n,1));
%     for p = 1 : n
%         V(p) = A(r(p), s(p));
%     end
% end

function i = r(p)
    low = ceil(sqrt(2*p+0.25)+0.5);
    up = floor(sqrt(2*p-1.75)+1.5);
    if low == up
        i = low;
    else 
        error('');
    end
end

function j = s(p)
    low = ceil(sqrt(2*p+0.25)+0.5);
    up = floor(sqrt(2*p-1.75)+1.5);
    if low == up
        i = low;
    else 
        error('');
    end
    j = p - (i-1)*(i-2)/2;
end