% this function aims to get the sample distribution of parameter estimation
% for PWGP, the results are saved as *.mat for further processing 

addpath('..\..\..\Stochastic_PWGP\')

initSetting_2;
iter = 50000;
r = 10;

initTheta = pi/2 * ones(1, l*(l-1)/2);      %initial theta for search algorithm
initPhi = 2*ones(1, l*p);                   %initial phi for search algorithm
initSigma = 30*ones(1,l);
options = optimset('Algorithm','active-set', 'RelLineSrchBnd', 0.5, ...
    'RelLineSrchBndDuration', 500, 'Display','off');


phi = zeros(iter, l*p);
theta = zeros(iter, l*(l-1)/2);
beta = zeros(iter, l);
sigma = zeros(iter, l);
Tao = zeros(iter, l*(l-1)/2);
rndErr = zeros(iter, 1);

% multivator model fitting
theta0 = [  initPhi     initTheta   initSigma];
UB = [ 3*ones(1,l*p)            pi*ones(1, l*(l-1)/2)-0.2   100*ones(1,l) ];
LB = [ 1*ones(1,l*p)            zeros(1, l*(l-1)/2)+0.2     10*ones(1,l)  ];

parfor k = 1 : iter

    disp(k);
    [design, ~] = randomSP(design0, trial, tbeta', tsigma',tphi, ttheta, trndErr, r);

    [dmodelPW, perfPW] = dacefit_Pairwise(design, @regpoly0, {@corr_PW_gauss @corr_MV_gauss}, theta0, LB, UB, 'fmincon', options);
    
    phi(k,:) = dmodelPW.theta(1:l*p);
    beta(k,:) = dmodelPW.beta';
    sigma(k,:) = dmodelPW.sigma';
    theta(k,:) = dmodelPW.theta(l*p+(1:l*(l-1)/2));
    Tao(k,:) = trilelm(dmodelPW.CC, -1)';
    rndErr(k,:) = dmodelPW.rndErr;
    
end
