% by modyfing the function "initSetting_*.m", one can get the theoretical
% asymptotic distribution as given in the equation 7 of the paper
addpath('..\..\..\Stochastic_PWGP');
initSetting_1;

% get J and H as defined in the equation (7) and (8) of the paper
% [J, H] = asymp_cov_parfor(design, @regpoly0, tphi, tsigma, ttheta, trndErr);  % use parfor to speed up
[J, H] = asymp_cov(design, @regpoly0, tphi, tsigma, ttheta, trndErr);
B1 = average_coeff(l, 2*size(H,1)/(l*(l-1)));
acov1 = B1*(inv(H)*J*inv(H)')*B1';  

dT = derv_T(4, ttheta);
B2 = blkdiag(eye(size(acov1,1)-size(dT,1)),dT');
acov2 = B2*acov1*B2';   