function L = PD(T)
    % matrix construction based on hypersphere decomposition
    % T:  parameters 
    if isempty(T)
        L = 1;
        return;
    end
    J = ceil(sqrt(2*length(T)));  % number of levels
    % if J*(J-1)/2 ~= length(T)  error('Incorrect number of parameters!'), end
    L = zeros(J,J); % initialize L matrix

    L(1,1) = 1;
    L(2,1) = cos(T(1));
    L(2,2) = sin(T(1));

    for i = 3 : J  % row index in L
        id = (i-1)*(i-2)/2 + 1; % starting parameter for row i
        L(i,1) = cos(T(id));
        for j = 2 : i-1
            k = 1;
            L(i,j) = sin(T(id));
            while k < j-1  L(i,j) = L(i,j)*sin(T(id+k));k = k + 1;end
            L(i,j) = L(i,j)*cos(T(id+j-1));
        end
        L(i,i) = L(i,i-1)/cos(T(id+i-2))*sin(T(id+i-2));
    end
    L((abs(L) < 1e-16)) = 0;

